/* 
 * Tara Graeve
 * COMP 2673 Assignment 3
 */

package comp2673assign3;

public class FireProbability {
	
	/*
	 * // given a density "d"
fireSpreadCount = 0

repeat 10,000 times:
  create a forest f of size 20x20 with density d
  if "fire spreads in f"
     fireSpreadCount++

// the probability of fire spreading in forests of density "d" is:
fireSpreadCount / 10,000
	 */
	
	public static double probabilityOfFireSpreadDFS(double d) {
		int fireSpreadCount = 0; 
		
		for(int i = 0; i < 10000; ++i) {
			Forest f = new Forest(20,20,d); 
			if(f.depthFirstSearch() == true) {
				fireSpreadCount++; 
			}
		}
		
		return fireSpreadCount/10000; 
		
	}
	
	public static double probabilityOfFireSpreadBFS(double d) {
		int fireSpreadCount = 0; 
		
		for(int i = 0; i < 10000; ++i) {
			Forest f = new Forest(20,20,d); 
			if(f.breadthFirstSearch() == true) {
				fireSpreadCount++; 
			}
		}
		
		return fireSpreadCount/10000; 
		
	}
	
	/*lowDensity = 0.0
highDensity = 1.0

repeat 20 times:
  // check the midpoint
  density = (highDensity + lowDensity) / 2.0

  // get probability of fire spreading in forests of 'density'
  p = probabilityOfFireSpreading( density )

  // check probability of fire spreading
  if p < 0.5
    // low probability: density can be increased
    lowDensity = density
  else
    // high probability: density should be decreased
    highDensity = density

// the last value of "density" is the value we seek
return density
	 */
	
	public static double highestDensityDFS() {
		int n = 0; 
		double lowDensity = 0.0; 
		double highDensity = 1.0; 
		double density = (highDensity + lowDensity) / 2.0; 

		
		while(n < 20) {
			density = (highDensity + lowDensity) / 2.0; 
			double p = probabilityOfFireSpreadDFS(density); 
			if(p < 0.5) {
				lowDensity = density; 
			} else {
				highDensity = density; 
			}
			n++; 
		}
		return density; 
	}
	
	public static double highestDensityBFS() {
		int n = 0; 
		double lowDensity = 0.0; 
		double highDensity = 1.0; 
		double density = (highDensity + lowDensity) / 2.0; 

		
		while(n < 20) {
			density = (highDensity + lowDensity) / 2.0; 
			double p = probabilityOfFireSpreadBFS(density); 
			if(p < 0.5) {
				lowDensity = density; 
			} else {
				highDensity = density; 
			}
			n++; 
		}
		return density; 
		
	}
	
	

}
